//+------------------------------------------------------------------+
//| boItalianJob Matrix_v3.mq4
//+------------------------------------------------------------------+
#property copyright "Copyright 01.09.2014, SwingMan"
#property link      "http://www.forexfactory.com/showthread.php?t=499706"

string IndicatorName="boItalianJob Matrix_v3";

#property indicator_separate_window

/*--------------------------------------------------------------------
28.08.2014  v1 - CONDITIONS FOR THE CURRENT BAR:
               6- SIGNAL                            3
               5- Close above/below Bollinger Band  3
               4- Stochastic1                       3
               3- Stochastic2                       3
               2- BB on RSI (2 conditions)          3
               1- ADX                               2 = 17
29.08.2014  v2 - Stochastic 1 and 2
               - ShowLeftTime until bar end
01.09.2014  v3 - Alerts               
--------------------------------------------------------------------*/

#property indicator_buffers 17
//...............................................
#define colorOK clrDodgerBlue       //ADX
#define colorNOK clrSilver
//...............................................
#property indicator_color1 clrForestGreen //Signal=3
#property indicator_color2 clrRed
#property indicator_color3 clrSilver

#property indicator_color4 clrForestGreen   //Close/BB
#property indicator_color5 clrRed
#property indicator_color6 clrSilver

#property indicator_color7 clrForestGreen //BB auf RSI
#property indicator_color8 clrRed
#property indicator_color9 clrSilver

#property indicator_color10 clrForestGreen //Stochastic1
#property indicator_color11 clrRed
#property indicator_color12 clrSilver

#property indicator_color13 clrForestGreen //Stochastic2
#property indicator_color14 clrRed
#property indicator_color15 clrSilver

#property indicator_color16 clrDodgerBlue
#property indicator_color17 clrSilver
//...............................................
#define levSignal 6
#define levCloseBB 5
#define levBBRSI 4
#define levStoch1 3
#define levStoch2 2
#define levADX 1
//...............................................
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 1
#property indicator_width4 0
#property indicator_width5 0
#property indicator_width6 1
#property indicator_width7 1
#property indicator_width8 1
#property indicator_width9 1
#property indicator_width10 1
#property indicator_width11 1
#property indicator_width12 1
#property indicator_width13 1
#property indicator_width14 1
#property indicator_width15 1
#property indicator_width16 2
#property indicator_width17 1
//...............................................
#property indicator_minimum 0
#property indicator_maximum 7
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum EXPIRATION_PERIOD
  {
   //exp_auto=0,
   exp_M1=60,
   exp_M2=PERIOD_M2*60,
   exp_M5=PERIOD_M5*60,
   exp_M10=PERIOD_M10*60,
   exp_M15=PERIOD_M15*60,
   exp_M30=PERIOD_M30*60,
   exp_H1=PERIOD_H1*60
  };
//---- inputs
//====================================================================
extern EXPIRATION_PERIOD Expiration_Period=exp_M5;
input string ____Signals="-----------------------------------------";
input bool Draw_VerticalLines=true;
input bool Draw_Arrows=false;
input bool Show_LeftTime=true;
input bool Send_Alert=true;
input bool Send_Email=false;
input bool Write_Comment=true;
input string ____BollingerBand="-----------------------------------------";
input int    Bands_Period=20;
input double Bands_Deviation=2.2;
input ENUM_APPLIED_PRICE Bands_Price=PRICE_CLOSE;
int    BandsShift=0;
input string ____RelativeStrengthIndex_RSI="-----------------------------------------";
input int    RSI_UpperLevel=70;
input int    RSI_LowerLevel=30;
input ENUM_APPLIED_PRICE RSI_Price=PRICE_CLOSE;
input int    RSI_Period=14;
input int    Bands_RSIPeriod=20;
input double Bands_RSIDeviation=2.0;
input string ____Stochastic1="-----------------------------------------";
//input bool Enable_Stochastic1_Signals=true;
input int    Stoch1_PeriodK=14;
input int    Stoch1_PeriodD=3;
input int    Stoch1_Slowing=1;
input int    Stoch1_UpperLevel=90;
input int    Stoch1_LowerLevel=10;
ENUM_STO_PRICE Stoch_PriceField=STO_LOWHIGH;
ENUM_MA_METHOD Stoch_MAmethod=MODE_SMA;
input string ____Stochastic2="-----------------------------------------";
extern bool Enable_Stochastic2_Signals=false;
input int    Stoch2_PeriodK=12;
input int    Stoch2_PeriodD=3;
input int    Stoch2_Slowing=3;
input int    Stoch2_UpperLevel=90;
input int    Stoch2_LowerLevel=10;
input string ____ADX_Filter="-----------------------------------------";
input bool Enable_ADX_Filter=false;
input int    ADX_Level=30;
input int    ADX_Period=14;
input ENUM_APPLIED_PRICE ADX_Price=PRICE_CLOSE;
//
int ATR_Period=14;
int ATR_SmoothingPeriod=5;
//====================================================================

//---- buffers
//-- matrix
double buffSigUP[],buffSigDN[],buffSigNO[];
double buffBBCrossUP[],buffBBCrossDN[],buffBBCrossNO[];
double buffStoch1UP[],buffStoch1DN[],buffStoch1NO[];
double buffStoch2UP[],buffStoch2DN[],buffStoch2NO[];
double buffBBRSIUP[],buffBBRSIDN[],buffBBRSINO[];
double buffADXOK[],buffADXNO[];
//-- indicators
double bandChartUpper[],bandChartLower[];
double bandRSIUpper[],bandRSILower[];
double PosBuffer[],NegBuffer[];
double stochastic1[],stochastic2[],rsi[],adx[];
double signalValue[],signalAlert[];
double entryValue[];

//---- constants
string CR="\n";
int iWindow= -1;
int iCorner= 3;
int rowTextHeight=8;

int yStep=13;
int xx0= 3;
int yy0= 7;
int yy;

int TREND_UP=  100;
int TREND_DN= -100;
int TREND_NO=990;

string sObjName1_Expiration="text2_Expiration";
string sObjName2_LeftTime  ="text2_LeftTime";

color ColorTradeUP=clrDodgerBlue;
color ColorTradeDN=clrDeepPink;

//---- variables
//---- time periods
int ExpirationPeriod;
datetime thisTime,oldTime;
bool newBar;
double dATR;
bool bDayIsSunday;
int iBBCrossCondition;
bool bCrossUpLower2,bCrossUpLower1,bCrossUpUpper1,bCrossUpUpper2;
bool bCrossDnLower2,bCrossDnLower1,bCrossDnUpper1,bCrossDnUpper2;
bool bCrossUp,bCrossDn;

bool bFirstCalculation;

//---- signals
int nSignalsUP,nSignalsDN;
int nBars;
int tLastSignal,tLastTradeDirection;
bool bTradeOK;
double dEntryValue;
int nWins,nWinsLong,nWinsShort;
int nLoss,nLossLong,nLossShort;
double nWinPoints,nLossPoints;
string sExpiration;
bool bExpirationPeriodOK;

//---- includes
#include <stderror.mqh>
#include <stdlib.mqh>
//
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit(void)
  {
//---- indicators ------------------
   int iArrowTNO=110;

   int iArrowSigUP=221; //233; //221;
   int iArrowSigDN=222; //234; //222;
   int iArrowSigNO=159;

   int iArrowOpenUP=217;
   int iArrowOpenDN=218;

   SetIndexBuffer(0,buffSigUP); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,iArrowSigUP); SetIndexLabel(0,"Signal UP");
   SetIndexBuffer(1,buffSigDN); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,iArrowSigDN); SetIndexLabel(1,"Signal DOWN");
   SetIndexBuffer(2,buffSigNO); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,iArrowSigNO); SetIndexLabel(2,NULL);

   SetIndexBuffer(3,buffBBCrossUP); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,iArrowTNO); SetIndexLabel(3,NULL); //SetIndexLabel(3,"BB-CrossUP");
   SetIndexBuffer(4,buffBBCrossDN); SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,iArrowTNO); SetIndexLabel(4,NULL); //SetIndexLabel(4,"BB-CrossDN");
   SetIndexBuffer(5,buffBBCrossNO); SetIndexStyle(5,DRAW_ARROW); SetIndexArrow(5,iArrowSigNO); SetIndexLabel(5,NULL);

   SetIndexBuffer(6,buffBBRSIUP); SetIndexStyle(6,DRAW_ARROW); SetIndexArrow(6,iArrowOpenUP); SetIndexLabel(6,NULL);
   SetIndexBuffer(7,buffBBRSIDN); SetIndexStyle(7,DRAW_ARROW); SetIndexArrow(7,iArrowOpenDN); SetIndexLabel(7,NULL);
   SetIndexBuffer(8,buffBBRSINO); SetIndexStyle(8,DRAW_ARROW); SetIndexArrow(8,iArrowSigNO); SetIndexLabel(8,NULL);

   SetIndexBuffer(9,buffStoch1UP); SetIndexStyle(9,DRAW_ARROW); SetIndexArrow(9,iArrowOpenUP); SetIndexLabel(9,NULL); //SetIndexLabel(6,"Stoch1UP");
   SetIndexBuffer(10,buffStoch1DN); SetIndexStyle(10,DRAW_ARROW); SetIndexArrow(10,iArrowOpenDN); SetIndexLabel(10,NULL); //SetIndexLabel(7,"Stoch1DN");
   SetIndexBuffer(11,buffStoch1NO); SetIndexStyle(11,DRAW_ARROW); SetIndexArrow(11,iArrowSigNO); SetIndexLabel(11,NULL);

   SetIndexBuffer(12,buffStoch2UP); SetIndexStyle(12,DRAW_ARROW); SetIndexArrow(12,iArrowOpenUP); SetIndexLabel(12,NULL); //SetIndexLabel(9,"Stoch2UP");
   SetIndexBuffer(13,buffStoch2DN); SetIndexStyle(13,DRAW_ARROW); SetIndexArrow(13,iArrowOpenDN); SetIndexLabel(13,NULL); //SetIndexLabel(10,"StochDN");
   SetIndexBuffer(14,buffStoch2NO); SetIndexStyle(14,DRAW_ARROW); SetIndexArrow(14,iArrowSigNO); SetIndexLabel(14,NULL);

   SetIndexBuffer(15,buffADXOK); SetIndexStyle(15,DRAW_ARROW); SetIndexArrow(15,iArrowSigNO); SetIndexLabel(15,NULL); //SetIndexLabel(15,"ADX-OK");
   SetIndexBuffer(16,buffADXNO); SetIndexStyle(16,DRAW_ARROW); SetIndexArrow(16,iArrowSigNO); SetIndexLabel(16,NULL); //SetIndexLabel(16,"ADX-NOK");

//--- Zustzliche Buffers
   IndicatorBuffers(30);
   SetIndexBuffer(17,bandChartUpper);
   SetIndexBuffer(18,bandChartLower);
   SetIndexBuffer(19,bandRSIUpper);
   SetIndexBuffer(20,bandRSILower);
   SetIndexBuffer(21,stochastic1);
   SetIndexBuffer(22,stochastic2);
   SetIndexBuffer(23,rsi);
   SetIndexBuffer(24,adx);
   SetIndexBuffer(25,entryValue);
   SetIndexBuffer(26,PosBuffer);
   SetIndexBuffer(27,NegBuffer);
   SetIndexBuffer(28,signalValue);
   SetIndexBuffer(29,signalAlert);

   IndicatorDigits(Digits);
   SetIndexDrawBegin(0,Bands_Period+RSI_Period);
   SetIndexDrawBegin(1,Bands_Period+RSI_Period);
   SetIndexDrawBegin(2,Bands_Period+RSI_Period);
   SetIndexDrawBegin(3,Bands_Period+RSI_Period);
   SetIndexDrawBegin(4,Bands_Period+RSI_Period);
   SetIndexDrawBegin(5,Bands_Period+RSI_Period);
   SetIndexDrawBegin(6,Bands_Period+RSI_Period);
   SetIndexDrawBegin(7,Bands_Period+RSI_Period);
   SetIndexDrawBegin(8,Bands_Period+RSI_Period);
   SetIndexDrawBegin(9,Bands_Period+RSI_Period);
   SetIndexDrawBegin(10,Bands_Period+RSI_Period);
   SetIndexDrawBegin(11,Bands_Period+RSI_Period);
   SetIndexDrawBegin(12,Bands_Period+RSI_Period);
   SetIndexDrawBegin(13,Bands_Period+RSI_Period);
   SetIndexDrawBegin(14,Bands_Period+RSI_Period);
   SetIndexDrawBegin(15,Bands_Period+RSI_Period);
   SetIndexDrawBegin(16,Bands_Period+RSI_Period);

//--Matrix name
   IndicatorShortName(IndicatorName);
   iWindow=WindowFind(IndicatorName);

   if(iWindow!=-1)
      Write_InfoText();
   else iWindow=WindowFind(IndicatorName);

//--- initialization done
   bFirstCalculation=true;
   bTradeOK=false;
   for(int i=Bars; i>=0; i--)
     {
      signalValue[i]=0;
      signalAlert[i]=0;
     }

//-- expiration times
//if(Expiration_Period==exp_auto)
//  {
//   if(Period()==PERIOD_M1)  {Expiration_Period=exp_M5;} else
//   if(Period()==PERIOD_M5)  {Expiration_Period=exp_M15;} else
//   if(Period()==PERIOD_M15) {Expiration_Period=exp_H1;} else
//   if(Period()==PERIOD_M30) {Expiration_Period=exp_H1;} else
//   if(Period()==PERIOD_H1)  {Expiration_Period=exp_H1;}
//  }
   ExpirationPeriod=Expiration_Period/60;
   if(ExpirationPeriod==PERIOD_M1)  sExpiration="1 min"; else
   if(ExpirationPeriod==PERIOD_M2)  sExpiration="2 min"; else
   if(ExpirationPeriod==PERIOD_M5)  sExpiration="5 min"; else
   if(ExpirationPeriod==PERIOD_M10) sExpiration="10 min"; else
   if(ExpirationPeriod==PERIOD_M15) sExpiration="15 min"; else
   if(ExpirationPeriod==PERIOD_M30) sExpiration="30 min"; else
   if(ExpirationPeriod==PERIOD_H1)  sExpiration="60 min";

   if(ObjectFind(0,sObjName1_Expiration)>0) ObjectDelete(0,sObjName1_Expiration);
   if(ObjectFind(0,sObjName2_LeftTime)>0) ObjectDelete(0,sObjName2_LeftTime);

   bExpirationPeriodOK=(ExpirationPeriod>=Period());

   return(INIT_SUCCEEDED);
  }
////+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   Comment("");
   DeleteAllObjects("text2_");
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate (const int rates_total,      // size of input time series
                 const int prev_calculated,  // bars handled in previous call
                 const datetime& time[],     // Time
                 const double& open[],       // Open
                 const double& high[],       // High
                 const double& low[],        // Low
                 const double& close[],      // Close
                 const long& tick_volume[],  // Tick Volume
                 const long& volume[],       // Real Volume
                 const int& spread[]         // Spread
                 )
  {
   int i,limit;
//----------------------------------
   if(iWindow!=-1)
      Write_InfoText();
   else iWindow=WindowFind(IndicatorName);

   if(Show_LeftTime)
      Show_LeftTimeValue();

   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

//-- calculation step 1 ------------
   for(i=limit; i>=0; i--)
     {
      Get_RSIValues(i);
     }
//Comment(
//        "time = ",TimeToString(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS),CR,
//        "limit= ",limit
//        );
//----------------------------------
   for(i=limit; i>=0; i--)
     {

      double ValStochastic2=iStochastic(Symbol(),Period(),Stoch2_PeriodK,Stoch2_PeriodD,Stoch2_Slowing,Stoch_MAmethod,Stoch_PriceField,MODE_MAIN,i);
      //-- conditions ---------------------------------
      //bool bStochasticUpper2=(stochastic2[iBar]>=Stoch2_UpperLevel);
      //bool bStochasticLower2=(stochastic2[iBar]<=Stoch2_LowerLevel);

      //if(Time[i]==D'2014.08.29 23:13')
      //   Comment(
      //           "Time= ",TimeToString(Time[i],TIME_DATE|TIME_MINUTES|TIME_SECONDS),CR,
      //           "ValStochastic2=",DoubleToString(ValStochastic2,4)
      //           );

      //-- check sunday day
      int iDayOfWeek=TimeDayOfWeek(Time[i]);
      bDayIsSunday=(iDayOfWeek==SUNDAY);

      //-- get new Bar
      thisTime=Time[i];
      if(thisTime!=oldTime)
        {
         oldTime=thisTime;
         newBar=true;
         //Print("   ### ",TimeToString(Time[i],TIME_DATE|TIME_MINUTES));         
        }
      else
         newBar=false;

      //-- Achtung im live indicator!
      if(newBar)
         nBars++;
      //***************************************
      // 1. ATR
      //***************************************
      if(newBar)
        {
         double thisATR=0;
         int sumI=0;

         for(int ia=1; ia<=ATR_SmoothingPeriod; ia++)
           {
            thisATR=thisATR+iATR(Symbol(),Period(),ATR_Period,i+ia);
            sumI++;
           }
         dATR=thisATR/sumI;
        }

      //***************************************
      // 1. Bollinger Band on Chart
      //***************************************      
      Get_BollCrossCondition(i);

      //***************************************
      // 2. Stochastic condition
      //***************************************      
      Get_StochasticCondition(i);

      //***************************************
      // 3. BB on RSI condition
      //***************************************            
      Get_BollingerRSICondition(i);

      //***************************************
      // 4. ADX condition
      //***************************************      
      Get_AdxCondition(i);

      //********************************************
      // 5. Trading signal
      //********************************************  
      Get_TradingSignal(i);

      //********************************************
      // Auswertung
      //********************************************  
      if(bFirstCalculation && bExpirationPeriodOK)
         Get_TradeResult(i);
     }

//-----------------------------------------------
   if(bExpirationPeriodOK==false)
      Comment("");
   else
   if(Write_Comment && bFirstCalculation)
     {
      //double nWochen=nBars/5.0;
      double nWochen=nBars*Period()/(PERIOD_W1-2*PERIOD_D1);
      double nSignals=nSignalsUP+nSignalsDN;
      if(nWochen>0)
         double nWochenSignals=nSignals/nWochen;
      if(Digits==3 || Digits==5)
        {
         nWinPoints=nWinPoints/10;
         nLossPoints=nLossPoints/10;
        }
      int iSpread=MarketInfo(Symbol(),MODE_SPREAD);

      double nWinSpread=iSpread*Point*(nWinsLong+nWinsShort);
      double nLossSpread=iSpread*Point*(nLossLong+nLossShort);

      double nWinPointsSpread=nWinPoints-nWinSpread;
      double nLossPointsSpread=nLossPoints+nLossSpread;

      if(nSignals>0)
         double dPointsPerSignal=(nWinPointsSpread+nLossPointsSpread)/Point/nSignals;

      //-- percents
      double percentLong=100*nWinsLong/(nWinsLong+nLossLong);
      double percentShort=100*nWinsShort/(nWinsShort+nLossShort);
      double percentAll=100*(nWinsLong+nWinsShort)/(nWinsLong+nLossLong+nWinsShort+nLossShort);
      Comment(
              "FirstBar=",TimeToString(iTime(Symbol(),Period(),Bars-(Bands_Period+RSI_Period)-1),TIME_DATE|TIME_MINUTES),CR,
              "LastBar =",TimeToString(Time[0],TIME_DATE|TIME_MINUTES),CR,
              "nBars   =",nBars,CR,
              "nSignalsUP= ",nSignalsUP,CR,
              "nSignalsDN= ",nSignalsDN,CR,CR,
              "nSignals= ",DoubleToString(nSignals,0),"  (win "+DoubleToString(percentAll,1)+" %)",CR,
              "nWeeks= ",DoubleToString(nWochen,1),CR,
              "nSignals/Week= ",DoubleToString(nWochenSignals,1),CR,

              "Spread= ",iSpread,CR,CR,
              //"nWinPoints: ",DoubleToString(nWinPoints/Point,0),
              //" - Spread: ",DoubleToString(nWinSpread/Point,0),
              //"  = ",DoubleToString(nWinPointsSpread/Point,0),CR,
              //
              //              "nLossPoints: ",DoubleToString(nLossPoints/Point,0),
              //              " - Spread: ",DoubleToString(nLossSpread/Point,0),
              //              "  = ",DoubleToString(nLossPointsSpread/Point,0),CR,
              //
              //              "WinPoints/Signal= ",DoubleToString(dPointsPerSignal,0),CR,CR,

              "nWinsLong =",nWinsLong,";  nLossLong =",nLossLong,"  ("+DoubleToString(percentLong,1)+" %)",CR,
              "nWinsShort=",nWinsShort,";  nLossShort=",nLossShort,"  ("+DoubleToString(percentShort,1)+" %)"
              );
     }
//----           
   bFirstCalculation=false;
   return(rates_total);
  }
//
////+------------------------------------------------------------------+
////|                                                                  |
////+------------------------------------------------------------------+
void Get_TradeResult(int iBar)
  {
   double dSpread=MarketInfo(Symbol(),MODE_SPREAD)*Point;

//-- signal at previous bar; get entry -------
   if(signalValue[iBar+1]==TREND_UP || signalValue[iBar+1]==TREND_DN)
      entryValue[iBar]=Open[iBar];
   else
      entryValue[iBar]=0;

//-- bar at expiration period ----------------
   int expirBars=Expiration_Period/60/Period();
   int entryBar=iBar+expirBars;
   int signalBar=entryBar+1;
   double dOpen=Open[iBar];

//-- long trades -----------------------------  ### es fehlen die equals open=entry!
   if(signalValue[signalBar]==TREND_UP && entryValue[entryBar]!=0)
     {
      nSignalsUP++;
      if(dOpen>entryValue[entryBar])
        {
         nWinsLong++;
         nWinPoints=nWinPoints+(dOpen-entryValue[entryBar]);
         Draw_TradingLine("win",entryBar,entryValue[entryBar],iBar,dOpen);
        }
      else
        {
         nLossLong++;
         nLossPoints=nLossPoints+(dOpen-entryValue[entryBar]);
         Draw_TradingLine("loss",entryBar,entryValue[entryBar],iBar,dOpen);
        }
     }
//-- short trades ----------------------------   
   if(signalValue[signalBar]==TREND_DN && entryValue[entryBar]!=0)
     {
      nSignalsDN++;
      if(dOpen<entryValue[entryBar])
        {
         nWinsShort++;
         nWinPoints=nWinPoints+(entryValue[entryBar]-dOpen);
         Draw_TradingLine("win",entryBar,entryValue[entryBar],iBar,dOpen);
        }
      else
        {
         nLossShort++;
         nLossPoints=nLossPoints+(entryValue[entryBar]-dOpen);
         Draw_TradingLine("loss",entryBar,entryValue[entryBar],iBar,dOpen);
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Write_InfoText() export
  {
   yy=yy0;
   string sText;
   color clrText=clrDodgerBlue;

   sText="ADX-Filter";
   SetLabelObject("text2_adx",sText,clrText,xx0,yy);

   yy=yy+yStep;
   sText="Stochastic2";
   SetLabelObject("text2_stochastic2",sText,clrText,xx0,yy);

   yy=yy+yStep;
   sText="Stochastic1";
   SetLabelObject("text2_stochastic1",sText,clrText,xx0,yy);

   yy=yy+yStep;
   sText="Band/RSI";
   SetLabelObject("text2_bbRSI",sText,clrText,xx0,yy);

   yy=yy+yStep;
   sText="Band-Cross";
   SetLabelObject("text2_bandCross",sText,clrText,xx0,yy);

   yy=yy+yStep;
   sText="## SIGNAL ##";
   SetLabelObject("text2_signal",sText,clrText,xx0,yy);
  }
//
//********************************************
// 1. Bollinger Band Cross Condition
//********************************************  
void Get_BollCrossCondition(int iBar)
  {
   double dClose=Close[iBar];

   bandChartUpper[iBar]=iBands(Symbol(),Period(), Bands_Period,Bands_Deviation,BandsShift,Bands_Price,MODE_UPPER,iBar);
   bandChartLower[iBar]=iBands(Symbol(),Period(), Bands_Period,Bands_Deviation,BandsShift,Bands_Price,MODE_LOWER,iBar);

//-- conditions ---------------------------------
   bool bCrossUpperBand=(dClose>=bandChartUpper[iBar]);
   bool bCrossLowerBand=(dClose<=bandChartLower[iBar]);

//-- matrix -------------------------------------
   if(bCrossUpperBand)
     {
      buffBBCrossUP[iBar]=EMPTY_VALUE;
      buffBBCrossDN[iBar]=levCloseBB;
      buffBBCrossNO[iBar]=EMPTY_VALUE;
     }
   else
   if(bCrossLowerBand)
     {
      buffBBCrossUP[iBar]=levCloseBB;
      buffBBCrossDN[iBar]=EMPTY_VALUE;
      buffBBCrossNO[iBar]=EMPTY_VALUE;
     }
   else
     {
      buffBBCrossUP[iBar]=EMPTY_VALUE;
      buffBBCrossDN[iBar]=EMPTY_VALUE;
      buffBBCrossNO[iBar]=levCloseBB;
     }
  }
//
//********************************************
// 2. Stochastic Condition
//********************************************  
void Get_StochasticCondition(int iBar)
  {
//=====================================
//    Stochastic 1
//=====================================
   stochastic1[iBar]=iStochastic(Symbol(),Period(),Stoch1_PeriodK,Stoch1_PeriodD,Stoch1_Slowing,Stoch_MAmethod,Stoch_PriceField,MODE_MAIN,iBar);
//-- conditions ---------------------------------
   bool bStochasticUpper1=(stochastic1[iBar]>=Stoch1_UpperLevel);
   bool bStochasticLower1=(stochastic1[iBar]<=Stoch1_LowerLevel);

//if(Time[iBar]==D'2014.08.29 23:13')
//   Comment(
//           "stochastic1[iBar]=",DoubleToString(stochastic1[iBar],4)
//           );

//-- matrix -------------------------------------
   if(bStochasticUpper1)
     {
      buffStoch1UP[iBar]=EMPTY_VALUE;
      buffStoch1DN[iBar]=levStoch1;
      buffStoch1NO[iBar]=EMPTY_VALUE;
     }
   else
   if(bStochasticLower1)
     {
      buffStoch1UP[iBar]=levStoch1;
      buffStoch1DN[iBar]=EMPTY_VALUE;
      buffStoch1NO[iBar]=EMPTY_VALUE;
     }
   else
     {
      buffStoch1UP[iBar]=EMPTY_VALUE;
      buffStoch1DN[iBar]=EMPTY_VALUE;
      buffStoch1NO[iBar]=levStoch1;
     }

//=====================================
//    Stochastic 2
//=====================================   
   if(Enable_Stochastic2_Signals==false)
     {
      buffStoch2UP[iBar]=EMPTY_VALUE;
      buffStoch2DN[iBar]=EMPTY_VALUE;
      buffStoch2NO[iBar]=levStoch2;
      return;
     }

   stochastic2[iBar]=iStochastic(Symbol(),Period(),Stoch2_PeriodK,Stoch2_PeriodD,Stoch2_Slowing,Stoch_MAmethod,Stoch_PriceField,MODE_MAIN,iBar);
//-- conditions ---------------------------------
   bool bStochasticUpper2=(stochastic2[iBar]>=Stoch2_UpperLevel);
   bool bStochasticLower2=(stochastic2[iBar]<=Stoch2_LowerLevel);

//if(Time[iBar]==D'2014.08.29 23:13')
//   Comment(
//           "Time= ",TimeToString(Time[iBar],TIME_DATE|TIME_MINUTES|TIME_SECONDS),CR,
//           "stochastic2[iBar]=",DoubleToString(stochastic2[iBar],4)
//           );

//-- matrix -------------------------------------
   if(bStochasticUpper2)
     {
      buffStoch2UP[iBar]=EMPTY_VALUE;
      buffStoch2DN[iBar]=levStoch2;
      buffStoch2NO[iBar]=EMPTY_VALUE;
     }
   else
   if(bStochasticLower2)
     {
      buffStoch2UP[iBar]=levStoch2;
      buffStoch2DN[iBar]=EMPTY_VALUE;
      buffStoch2NO[iBar]=EMPTY_VALUE;
     }
   else
     {
      buffStoch2UP[iBar]=EMPTY_VALUE;
      buffStoch2DN[iBar]=EMPTY_VALUE;
      buffStoch2NO[iBar]=levStoch2;
     }
  }
//
//********************************************
// 3. Bollinger Band on RSI Condition
//********************************************  
void Get_RSIValues(int iBar)
  {
//-- RSI from BBRSI_v1 --------------------------
   double rel,negative,positive;
   int MAPeriod=1;
   double sumn=0.0,sump=0.0;
   for(int k=RSI_Period-1;k>=0;k--)
     {
      rel=iMA(NULL,0,MAPeriod,0,MODE_SMA,RSI_Price,iBar+k)-iMA(NULL,0,MAPeriod,0,MODE_SMA,RSI_Price,iBar+k+1);
      if(rel>0) sump+=rel;
      else      sumn-=rel;
     }
   positive=sump/RSI_Period;
   negative=sumn/RSI_Period;

   PosBuffer[iBar]=positive;
   NegBuffer[iBar]=negative;
   if(negative==0.0)
      rsi[iBar]=0.0;
   else
      rsi[iBar]=100.0-100.0/(1+positive/negative);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Get_BollingerRSICondition(int iBar)
  {
//-- RSI classic --------------------------------  
//for(int i=0; i<RSI_Period; i++)
//   rsi[iBar+i]=iRSI(Symbol(),Period(),RSI_Period,RSI_Price,iBar+i);



//-- band on RSI --------------------------------
   bandRSIUpper[iBar]=iBandsOnArray(rsi,0,Bands_RSIPeriod,Bands_RSIDeviation,0,MODE_UPPER,iBar);
   bandRSILower[iBar]=iBandsOnArray(rsi,0,Bands_RSIPeriod,Bands_RSIDeviation,0,MODE_LOWER,iBar);

//-- conditions ---------------------------------
   bool bBandRSIUP=(rsi[iBar]>=bandRSIUpper[iBar]) && (rsi[iBar]>=RSI_UpperLevel);
   bool bBandRSIDN=(rsi[iBar]<=bandRSILower[iBar]) && (rsi[iBar]<=RSI_LowerLevel);

//if(Time[iBar]==D'2014.08.28 15:30')
//   Comment(
//           "rsi[iBar]= ",DoubleToString(rsi[iBar],4),CR,
//           "BB-up1  =",DoubleToString(bandRSIUpper[iBar],4),CR,
//           "BB-down1=",DoubleToString(bandRSILower[iBar],4)
//           );

//-- matrix -------------------------------------
   if(bBandRSIUP)
     {
      buffBBRSIUP[iBar]=EMPTY_VALUE;
      buffBBRSIDN[iBar]=levBBRSI;
      buffBBRSINO[iBar]=EMPTY_VALUE;
     }
   else
   if(bBandRSIDN)
     {
      buffBBRSIUP[iBar]=levBBRSI;
      buffBBRSIDN[iBar]=EMPTY_VALUE;
      buffBBRSINO[iBar]=EMPTY_VALUE;
     }
   else
     {
      buffBBRSIUP[iBar]=EMPTY_VALUE;
      buffBBRSIDN[iBar]=EMPTY_VALUE;
      buffBBRSINO[iBar]=levBBRSI;
     }
  }
//
//********************************************
// 4. ADX Condition
//********************************************  
void Get_AdxCondition(int iBar)
  {
   adx[iBar]=iADX(Symbol(),Period(),ADX_Period,ADX_Price,MODE_MAIN,iBar);

//-- conditions ---------------------------------
   bool bAdxOK;
   if(Enable_ADX_Filter)
      bAdxOK=(adx[iBar]<=ADX_Level);
   else
      bAdxOK=false;

//-- matrix -------------------------------------
   if(bAdxOK)
     {
      buffADXOK[iBar]=levADX;
      buffADXNO[iBar]=EMPTY_VALUE;
     }
   else
     {
      buffADXOK[iBar]=EMPTY_VALUE;
      buffADXNO[iBar]=levADX;
     }
  }
//  
//********************************************
// Trading signal
//********************************************  
void Get_TradingSignal(int iBar)
  {
//-- condition stochastic 2 ------------------
   bool bCondLong_Stochastic2,bCondShort_Stochastic2;
   if(Enable_Stochastic2_Signals==false)
     {
      bCondLong_Stochastic2=true;
      bCondShort_Stochastic2=true;
     }
   else
     {
      bCondLong_Stochastic2=(buffStoch2UP[iBar]!=EMPTY_VALUE);
      bCondShort_Stochastic2=(buffStoch2DN[iBar]!=EMPTY_VALUE);
     }

//-- condition ADX ---------------------------
   bool bCondition_ADXfilter;
   if(Enable_ADX_Filter==false)
     {
      bCondition_ADXfilter=true;
     }
   else
     {
      bCondition_ADXfilter=(buffADXOK[iBar]!=EMPTY_VALUE);
     }

//============================================
//-- Long/Short conditions -------------------
   bool condLong=(buffBBCrossUP[iBar]!=EMPTY_VALUE) && //current Bar                 
                 (buffBBRSIUP[iBar]!=EMPTY_VALUE) && 
                 (buffStoch1UP[iBar]!=EMPTY_VALUE) && 
                 (bCondLong_Stochastic2) && 
                 (bCondition_ADXfilter);

   bool condShort=(buffBBCrossDN[iBar]!=EMPTY_VALUE) && //current Bar                 
                  (buffBBRSIDN[iBar]!=EMPTY_VALUE) && 
                  (buffStoch1DN[iBar]!=EMPTY_VALUE) && 
                  (bCondShort_Stochastic2) && 
                  (bCondition_ADXfilter);

//-- Signals ---------------------------------
   if(condLong)
     {
      buffSigUP[iBar]=levSignal;
      buffSigDN[iBar]=EMPTY_VALUE;
      buffSigNO[iBar]=EMPTY_VALUE;
      signalValue[iBar]=TREND_UP;
     }
   else if(condShort)
     {
      buffSigUP[iBar]=EMPTY_VALUE;
      buffSigDN[iBar]=levSignal;
      buffSigNO[iBar]=EMPTY_VALUE;
      signalValue[iBar]=TREND_DN;
     }
   else
     {
      buffSigUP[iBar]=EMPTY_VALUE;
      buffSigDN[iBar]=EMPTY_VALUE;
      buffSigNO[iBar]=levSignal;
      signalValue[iBar]=0;
     }

//============================================
//-- Draw vertical lines     
   string sVertLineName;
   if(Draw_VerticalLines)
     {
      sVertLineName="text2_"+"VL_"+TimeToString(Time[iBar]);
      if(signalValue[iBar]==0)
         ObjectDelete(sVertLineName);
      else
      if(signalValue[iBar]==TREND_UP)
         Draw_VerticalLine(sVertLineName,iBar,ColorTradeUP);
      else
      if(signalValue[iBar]==TREND_DN)
         Draw_VerticalLine(sVertLineName,iBar,ColorTradeDN);
     }
//============================================
//-- Draw Arrows     
   string sArrowName;
   if(Draw_Arrows)
     {
      sArrowName="text2_"+"AR_"+TimeToString(Time[iBar]);
      if(signalValue[iBar]==0)
         ObjectDelete(sArrowName);
      else
      if(signalValue[iBar]==TREND_UP)
         Draw_TradeArrow(TREND_UP,sArrowName,iBar,ColorTradeUP);
      else
      if(signalValue[iBar]==TREND_DN)
         Draw_TradeArrow(TREND_DN,sArrowName,iBar,ColorTradeDN);
     }
//============================================
//-- Send Alert -------------
//-- only today
   int iShift=iBarShift(Symbol(),PERIOD_D1,Time[iBar],true);
   if(iShift>0)
      return;
//((if(iTime(Symbol(),PERIOD_D1,0)==)

//-- sending
   string sTime="  (Bar "+TimeToString(Time[iBar],TIME_DATE|TIME_MINUTES)+")";

   string sAlertUP=" ItaJob  "+Symbol()+"  =BUY ="+sTime;
   string sAlertDN=" ItaJob  "+Symbol()+"  =SELL="+sTime;

//string sAlertUP=Symbol()+" ItaloJob BUY"+sTime;
//string sAlertDN=Symbol()+" ItaloJob SELL"+sTime;

   string subject="Trading ItaloJob";
   bool bAlertSended=false;

   if(Send_Alert)
     {
      //if(iBar==0 && signalValue[iBar+1]!=0 && signalAlert[iBar]!=1)
      if(signalValue[iBar+1]!=0 && signalAlert[iBar]!=1)
        {
         if(signalValue[iBar+1]==TREND_UP)
            Alert(sAlertUP);
         else
         if(signalValue[iBar+1]==TREND_DN)
            Alert(sAlertDN);
         bAlertSended=true;
        }
     }
//-- Send EMail -------------
   if(Send_Email)
     {
      //if(iBar==0 && signalValue[iBar+1]!=0 && signalAlert[iBar]!=1)
      if(signalValue[iBar+1]!=0 && signalAlert[iBar]!=1)
        {
         if(signalValue[iBar+1]==TREND_UP)
            SendMail(subject,sAlertUP);
         else
         if(signalValue[iBar+1]==TREND_DN)
            SendMail(subject,sAlertDN);
         bAlertSended=true;
        }
     }
   if((Send_Alert || Send_Email) && bAlertSended==true)
      signalAlert[iBar]=1;

//if(Time[iBar]==D'2014.08.27 03:25' || Time[iBar]==D'2014.08.27 09:10')
//{
//Print("");
//Print("  ### ",sTime);
//Print("iBar= ",iBar);
//Print("bAlertSended= ",bAlertSended);
//Print("signalValue[iBar+1]= ",signalValue[iBar+1]);
//Print("signalAlert[iBar]= ",signalAlert[iBar]);
//}      
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Show_LeftTimeValue()
  {
   color clr=clrGoldenrod;
   int textCorner=CORNER_RIGHT_LOWER;

   if(ObjectFind(sObjName1_Expiration)>0) ObjectDelete(sObjName1_Expiration);
   if(ObjectFind(sObjName2_LeftTime)>0) ObjectDelete(sObjName2_LeftTime);

//-- Text Expiration ---------------
   if(bExpirationPeriodOK)
     {
      string sObjName1=sObjName1_Expiration;
      string sText1="exp "+sExpiration;
      int xLabel1=2;
      int yLabel1=33;
      int textHeight1=15;

      if(ObjectFind(sObjName1)<0)
        {
         ObjectCreate(sObjName1,OBJ_LABEL,0,0,0);
         ObjectSetText(sObjName1,sText1,textHeight1,"Arial Bold",clr);
         ObjectSet(sObjName1,OBJPROP_CORNER,textCorner);
         ObjectSet(sObjName1,OBJPROP_XDISTANCE,xLabel1);
         ObjectSet(sObjName1,OBJPROP_YDISTANCE,yLabel1);
        }
      else
        {
         ObjectSetText(sObjName1,sText1,textHeight1,"Arial Bold",clr);
        }
     }
//-- Expiration Time ---------------
   string sObjName2=sObjName2_LeftTime;
   int xLabel2=2;
   int yLabel2=2;
   int textHeight2=20;

//-- expiration at this bar
   datetime timeLeft=Time[0]+Period()*60-TimeCurrent();
//-- expiration until exit
//datetime timeLeft=Time[0]+Expiration_Period-TimeCurrent();
   string sText2;
   if(Period()<PERIOD_H4)
     {
      sText2=TimeToString(timeLeft,TIME_MINUTES|TIME_SECONDS);
      sText2=StringSubstr(sText2,3,5);
     }
   else
     {
      sText2=TimeToString(timeLeft,TIME_DATE|TIME_MINUTES|TIME_SECONDS);
      sText2=StringSubstr(sText2,11,8);
     }
   sText2="< "+sText2;

   if(ObjectFind(sObjName2)<0)
     {
      ObjectCreate(sObjName2,OBJ_LABEL,0,0,0);
      ObjectSetText(sObjName2,sText2,textHeight2,"Arial Bold",clr);
      ObjectSet(sObjName2,OBJPROP_CORNER,textCorner);
      ObjectSet(sObjName2,OBJPROP_XDISTANCE,xLabel2);
      ObjectSet(sObjName2,OBJPROP_YDISTANCE,yLabel2);
     }
   else
     {
      ObjectSetText(sObjName2,sText2,textHeight2,"Arial Bold",clr);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetLabelObject(string sName,string sText,color dColor,int xxL,int yyL)
  {
   ObjectDelete(sName);
   ObjectCreate(sName,OBJ_LABEL,iWindow,0,0);
//ObjectSetText(sName,sText,rowTextHeight, "Courier", dColor);
   ObjectSetText(sName,sText,rowTextHeight,"Arial Bold",dColor);
   ObjectSet(sName,OBJPROP_CORNER,iCorner);
   ObjectSet(sName,OBJPROP_XDISTANCE,xxL);
   ObjectSet(sName,OBJPROP_YDISTANCE,yyL);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DeleteOneObject(string sName)
  {
   int nObjects=ObjectsTotal();
   for(int i=nObjects; i>=0; i--)
     {
      string nameObject=ObjectName(i);
      if(StringFind(nameObject,sName,0)>=0)
        {
         ObjectDelete(nameObject);
         break;
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DeleteAllObjects(string sName)
  {
   int nObjects=ObjectsTotal();
   for(int i=nObjects; i>=0; i--)
     {
      string nameObject=ObjectName(i);
      if(StringFind(nameObject,sName,0)>=0)
        {
         ObjectDelete(nameObject);
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Draw_VerticalLine(string objName,int iBar,color colorTrade)
  {
   ObjectCreate(objName,OBJ_VLINE,0,Time[iBar],0);
   ObjectSet(objName,OBJPROP_STYLE,STYLE_DASH);
   ObjectSet(objName,OBJPROP_COLOR,colorTrade);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Draw_TradeArrow(int trendCode,string objName,int iBar,color colorTrade)
  {
   double price1;
   int obj_arrow;
   if(trendCode==TREND_UP)
     {
      price1=Low[iBar]-dATR*0.5;
      obj_arrow=OBJ_ARROW_UP;
     }
   else
   if(trendCode==TREND_DN)
     {
      price1=High[iBar]+dATR*3.0;
      obj_arrow=OBJ_ARROW_DOWN;
     }

   ObjectCreate(objName,obj_arrow,0,Time[iBar],price1);
   ObjectSet(objName,OBJPROP_WIDTH,4);
   ObjectSet(objName,OBJPROP_COLOR,colorTrade);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
void Draw_TradingLine(string sResult,int entryBar,double price1,int iBar,double price2)
  {
   string objName="text2_"+"TL_"+TimeToString(Time[iBar]);
   color clrResult;
   if(sResult=="win")
      clrResult=ColorTradeUP;
   if(sResult=="loss")
      clrResult=ColorTradeDN;

   ObjectCreate(objName,OBJ_TREND,0,Time[entryBar],price1,Time[iBar],price2);
   ObjectSet(objName,OBJPROP_RAY,false);
   ObjectSet(objName,OBJPROP_COLOR,clrResult);
   ObjectSet(objName,OBJPROP_WIDTH,2);
  }
//+------------------------------------------------------------------+
